/*
  Algorithms IE171 - Lab 4 - Heap Sort
*/

#include "heap.hpp"
#include <fstream>
#include <iostream>
#include <algorithm>
#include <ctime>

using namespace std;

void insertionSort(Item * data, int length);

int main(int argc, char *argv[]) 
{  
  ifstream is(argv[1]);
  if (!is) {
    cerr << "Error, cannot open file: " << argv[1] << endl;
    return 0;
  }

  int length(0);
  is >> length;
  
  int lengthMax(length);
  Item * data     = new Item[lengthMax];
  
  for(int i = 0; i < length; i++)
    is >> data[i];

  is.close();

  clock_t start(clock());                // For running time

#if 0

  Heap hMax(data, length, lengthMax, 0);

  hMax.heapSort();

#else

  insertionSort(data, length);

#endif

  clock_t finish(clock());  
  double runTime = double (finish - start)/(CLOCKS_PER_SEC / 1000.0);

  cout << "Running time is " << runTime << " milliseconds." << endl;
  
  string outfile(argv[1]);

  outfile += ".sorted";
  ofstream os(outfile.c_str());
  os << length << endl;
  for (int pos = 0; pos < length; pos++) {
    os << data[pos] << endl;
  }
  os.close();

  delete [] data;
}

/*************************************************/

void insertionSort(Item * data, int length)
{
  int i, j;
  string t(data[0]);
  for(i = 0; i < length; i++){
     t = data[i];
    for(j = i-1; j >= 0 && t < data[j]; j--){
      data[j+1] = data[j];
    }
    data[j+1] = t;
  }
} 

